<html devsite="">
<head>
  <title>Host Controller Architecture</title>
  <meta name="project_path" value="/_project.yaml">
  <meta name="book_path" value="/_book.yaml">
</head>

<body>
  {% include "_versions.html" %}
  <!--
      Copyright 2018 The Android Open Source Project

      Licensed under the Apache License, Version 2.0 (the "License");
      you may not use this file except in compliance with the License.
      You may obtain a copy of the License at

          http://www.apache.org/licenses/LICENSE-2.0

      Unless required by applicable law or agreed to in writing, software
      distributed under the License is distributed on an "AS IS" BASIS,
      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
      See the License for the specific language governing permissions and
      limitations under the License.
  -->


  <p>
    The architecture of VTS test framework integrates with its cloud-based test
    serving service. A VTS Host Controller runs on a host machine and controls a
    test harness (e.g., TradeFed) instance as shown below:
  </p>

<p>
  <img src="images/vts-host-controller.png" width="" alt="Host controller architecture"
  title="Host controller architecture">
</p>
<figcaption>
  <strong>Figure 1.</strong> VTS Host Controller architecture
  </figcaption>

  <p>
  The controller pulls commands from a Cluster Commander running as a Google App
  Engine (GAE) instance, then relays commands and responses between its cluster
  commander and the test harness instance.
</p>

<p>This architecture includes the following advantages:
</p>

<ul>
  <li>Because it is <strong>decoupled from any test harness instance</strong>,
  it can control different types of test harnesses and is more robust. The
  alternative design (embedding the host control logic in a test harness) does
  not block errors from propagating.</li>
  <li>Because it uses a <strong>pull-based command-and-control (C&amp;C)
  model</strong>, it can work with different types of cloud-side cluster
  commanders as well as hosts that exist behind a firewall (for ingress
  connections). The alternative design (push-based C&amp;C model) may not allow
  a cloud commander to access host controller instances that exist on host
  computers in a private network.</li>
</ul>

</body>
</html>
